package com.jdc.jdcproject.controller;

import com.jdc.jdcproject.entity.DicekeMiningloss;
import com.jdc.jdcproject.entity.VO.DicekeTotalMiningVo;
import com.jdc.jdcproject.service.IDicekeMininglossService;
import com.jdc.jdcproject.service.IDicekeTotalMiningService;
import com.jdc.jdcproject.utils.Result;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.time.LocalDate;
import java.util.List;

/**
 * <p>
 * 采剥量报表; 前端控制器
 * </p>
 *
 * @author xvxboo
 */

/*
 * 该业务只是查询diceke_miningloss表，并不存在自己的数据库。
 * */
@RestController
@RequestMapping("/dicekeTotalMining")
public class DicekeTotalMiningController {

    @Autowired
    private IDicekeTotalMiningService dicekeTotalMiningService;
    @Autowired
    private IDicekeMininglossService dicekeMininglossService;

    @Operation(summary = "通过Month查询采剥量报表")
    @GetMapping("findTotalMiningByMonth/{Month}")
   public Result findTotalMiningByMonth(@RequestParam(required = false)
                                            @Parameter(description = "yyyy-MM-dd",example = "2002-10-11")LocalDate Month){
       List<DicekeTotalMiningVo> totalMiningVoList = dicekeTotalMiningService.getTotalMiningByMonth(Month);
       System.out.println(totalMiningVoList.toString());
       return Result.successResult().data("totalMiningVoList",totalMiningVoList);
   }

   @Operation(summary = "修改采剥量报表")
   @PostMapping("updateTotalMining")
   public Result updateTotalMining(@RequestBody DicekeTotalMiningVo dtm){

        DicekeMiningloss dml = new DicekeMiningloss();

       dml.setLossID(dtm.getTotalID());
       dml.setPlateID(dtm.getPlateID());
       dml.setShovelID(dtm.getShovelID());
       dml.setBeizhu(dtm.getBeizhu());
       dml.setStrippingTon(dtm.getStrippingTon());
       dml.setStrippingAndTotalMiningTon(dtm.getStrippingAndTotalMiningTon());
       dml.setMonth(dtm.getMonth());

        boolean updateFlag = dicekeMininglossService.updateById(dml);
        if (updateFlag){
            return Result.successResult();
        } else {
            return Result.errorResult();
        }


   }

   //TODO: 删除不清楚业务逻辑，是否直接删除所使用的diceke_miningloss表数据
    @Operation(summary = "删除采剥量报表")
    @DeleteMapping("deleteTotalMining/{totalID}")
    public Result deleteLoss(@PathVariable String totalID){
        boolean updateflag = dicekeMininglossService.removeById(totalID);
        if(updateflag){
            return Result.successResult();
        } else {
            return Result.errorResult();
        }
    }

}
