package com.jdc.jdcproject.entity.VO;

import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import io.swagger.v3.oas.annotations.media.Schema;
import lombok.Data;

import java.io.Serializable;
import java.time.LocalDate;
import java.util.Date;

/**
 * 泵站操作VO
 */
@Data
public class FangpaishuiPumpoperationrecordVo implements Serializable {
    /**
     * 主键，唯一标识操作记录
     */
    @TableId(value = "RecordID")
    @Schema(description = "主键")
    private Integer recordID;

    /**
     * 外键，关联操作的设备
     */
    @Schema(description = "设备ID")
    private Integer EquipmentId;

    /**
     * 外键，关联操作的机组
     */
    @Schema(description = "机组编码")
    private String unitCode;

    /**
     * 外键，关联操作的设备
     */
    @Schema(description = "设备名称")
    private String EquipmentName;

    /**
     * 外键，关联操作的机组
     */
    @Schema(description = "机组ID")
    private Integer unitID;

    /**
     * 额定排水量（固定属性）
     */
    @Schema(description = "额定排水量")
    private Integer ratedCapacity;

    /**
     * 班次（白班、零点班、四点班）
     */
    @Schema(description = "班次")
    private String sailings;

    /**
     * 操作类型（“排水”或“倒水”）
     */
    @Schema(description = "操作类型")
    private String operationType;

    /**
     * 操作时间（小时）
     */
    @Schema(description = "操作时间（小时）")
    private Double operationTime;

    /**
     * 排水量/倒水量（单位：立方米）
     */
    @Schema(description = "排水量/倒水量（单位：立方米）")
    private Integer volume;

    /**
     * 日期（格式：YYYY-MM-dd ）
     */
    @Schema(description = "日期")
    private LocalDate month;



    /**
     * 启动时间（格式：YYYY-MM-dd HH:mm:ss ）
     */
    @Schema(description = "启动时间")
    private Date startupTime;

    /**
     * 停止时间（格式：YYYY-MM-dd HH:mm:ss ）
     */
    @Schema(description = "停止时间")
    private Date endTime;

    @TableField(exist = false)
    private static final long serialVersionUID = 1L;

    @Override
    public boolean equals(Object that) {
        if (this == that) {
            return true;
        }
        if (that == null) {
            return false;
        }
        if (getClass() != that.getClass()) {
            return false;
        }
        FangpaishuiPumpoperationrecordVo other = (FangpaishuiPumpoperationrecordVo) that;
        return (this.getRecordID() == null ? other.getRecordID() == null : this.getRecordID().equals(other.getRecordID()))
            && (this.getUnitID() == null ? other.getUnitID() == null : this.getUnitID().equals(other.getUnitID()))
            && (this.getOperationType() == null ? other.getOperationType() == null : this.getOperationType().equals(other.getOperationType()))
            && (this.getOperationTime() == null ? other.getOperationTime() == null : this.getOperationTime().equals(other.getOperationTime()))
            && (this.getVolume() == null ? other.getVolume() == null : this.getVolume().equals(other.getVolume()))
            && (this.getMonth() == null ? other.getMonth() == null : this.getMonth().equals(other.getMonth()))
            && (this.getSailings() == null ? other.getSailings() == null : this.getSailings().equals(other.getSailings()))
            && (this.getStartupTime() == null ? other.getStartupTime() == null : this.getStartupTime().equals(other.getStartupTime()))
            && (this.getEndTime() == null ? other.getEndTime() == null : this.getEndTime().equals(other.getEndTime()));
    }

    @Override
    public int hashCode() {
        final int prime = 31;
        int result = 1;
        result = prime * result + ((getRecordID() == null) ? 0 : getRecordID().hashCode());
        result = prime * result + ((getUnitID() == null) ? 0 : getUnitID().hashCode());
        result = prime * result + ((getOperationType() == null) ? 0 : getOperationType().hashCode());
        result = prime * result + ((getOperationTime() == null) ? 0 : getOperationTime().hashCode());
        result = prime * result + ((getVolume() == null) ? 0 : getVolume().hashCode());
        result = prime * result + ((getMonth() == null) ? 0 : getMonth().hashCode());
        result = prime * result + ((getSailings() == null) ? 0 : getSailings().hashCode());
        result = prime * result + ((getStartupTime() == null) ? 0 : getStartupTime().hashCode());
        result = prime * result + ((getEndTime() == null) ? 0 : getEndTime().hashCode());
        return result;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", recordID=").append(recordID);
        sb.append(", unitID=").append(unitID);
        sb.append(", operationType=").append(operationType);
        sb.append(", operationTime=").append(operationTime);
        sb.append(", volume=").append(volume);
        sb.append(", month=").append(month);
        sb.append(", sailings=").append(sailings);
        sb.append(", startupTime=").append(startupTime);
        sb.append(", endTime=").append(endTime);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}