package com.jdc.jdcproject.service.impl;

import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.jdc.jdcproject.entity.FangpaishuiPumpoperationrecord;
import com.jdc.jdcproject.entity.VO.FangpaishuiPumpoperationrecordReportByMonthCountVo;
import com.jdc.jdcproject.entity.VO.FangpaishuiPumpoperationrecordReportByYearCountVo;
import com.jdc.jdcproject.entity.VO.FangpaishuiPumpoperationrecordReportVo;
import com.jdc.jdcproject.entity.VO.FangpaishuiPumpoperationrecordVo;
import com.jdc.jdcproject.service.FangpaishuiPumpoperationrecordService;
import com.jdc.jdcproject.mapper.FangpaishuiPumpoperationrecordMapper;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.stream.Collectors;

/**
* @author 95262
* @description 针对表【fangpaishui_pumpoperationrecord(泵站操作记录表;)】的数据库操作Service实现
* @createDate 2025-05-07 13:37:49
*/
@Service
public class FangpaishuiPumpoperationrecordServiceImpl extends ServiceImpl<FangpaishuiPumpoperationrecordMapper, FangpaishuiPumpoperationrecord>
    implements FangpaishuiPumpoperationrecordService{

    @Override
    public List<FangpaishuiPumpoperationrecordVo> findDetail(FangpaishuiPumpoperationrecordVo vo) {
        return baseMapper.findDetail(vo);
    }

    @Override
    public FangpaishuiPumpoperationrecordReportByYearCountVo findAll(String upDate, String lastDate) {
        List<FangpaishuiPumpoperationrecordVo> fangpaishuiPumpoperationrecordVos  = baseMapper.findAll(upDate,lastDate);
        //根据类型分组（排水/倒水）
        Map<String, List<FangpaishuiPumpoperationrecordVo>> stringListMap = fangpaishuiPumpoperationrecordVos.stream().collect(Collectors.groupingBy(FangpaishuiPumpoperationrecordVo::getOperationType));
        List<FangpaishuiPumpoperationrecordVo> fangpaishuiPumpoperationrecordVoPais = new ArrayList<>();
        List<FangpaishuiPumpoperationrecordVo> fangpaishuiPumpoperationrecordVoDao = new ArrayList<>();
        Set<Map.Entry<String, List<FangpaishuiPumpoperationrecordVo>>> entries = stringListMap.entrySet();
        for(Map.Entry m : entries){
        if (m.getKey().equals("排水")){
            fangpaishuiPumpoperationrecordVoPais.addAll((List<FangpaishuiPumpoperationrecordVo>) m.getValue());
        }else {
            fangpaishuiPumpoperationrecordVoDao.addAll((List<FangpaishuiPumpoperationrecordVo>) m.getValue());
        }
        }
        //排水根据机组合并数据
        fangpaishuiPumpoperationrecordVoPais = fangpaishuiPumpoperationrecordVoPais.stream().collect(Collectors.toMap(FangpaishuiPumpoperationrecordVo::getUnitID, a -> a, (o1,o2)-> {
            o1.setOperationTime(o1.getOperationTime() + o2.getOperationTime());
            o1.setVolume(o1.getVolume () + o2.getVolume ());
            return o1;
        })).values().stream().collect(Collectors.toList());

        //倒水根据机组合并数据
        fangpaishuiPumpoperationrecordVoDao = fangpaishuiPumpoperationrecordVoDao.stream().collect(Collectors.toMap(FangpaishuiPumpoperationrecordVo::getUnitID, a -> a, (o1,o2)-> {
            o1.setOperationTime(o1.getOperationTime() + o2.getOperationTime());
            o1.setVolume(o1.getVolume () + o2.getVolume ());
            return o1;
        })).values().stream().collect(Collectors.toList());

        //排水根据泵站分组
        Map<String, List<FangpaishuiPumpoperationrecordVo>> paiMap = fangpaishuiPumpoperationrecordVoPais.stream().collect(Collectors.groupingBy(FangpaishuiPumpoperationrecordVo::getEquipmentName));
        Set<Map.Entry<String, List<FangpaishuiPumpoperationrecordVo>>> paiEntries = paiMap.entrySet();
        List<FangpaishuiPumpoperationrecordReportVo>  fangpaishuiPumpoperationrecordReportVosPai = new ArrayList<>();
        for(Map.Entry m : paiEntries){

            FangpaishuiPumpoperationrecordReportVo vo = new FangpaishuiPumpoperationrecordReportVo();
            vo.setEquipmentName((String) m.getKey());
            vo.setFangpaishuiPumpoperationrecordVos((List<FangpaishuiPumpoperationrecordVo>) m.getValue());
            int VolumeByMouth =0;
            for (FangpaishuiPumpoperationrecordVo fangpaishuiPumpoperationrecordVo : (List<FangpaishuiPumpoperationrecordVo>) m.getValue()) {
                VolumeByMouth+=fangpaishuiPumpoperationrecordVo.getVolume();
            }
            vo.setVolumeByMouth(VolumeByMouth);
            fangpaishuiPumpoperationrecordReportVosPai.add(vo);
        }

        //倒水根据泵站分组
        Map<String, List<FangpaishuiPumpoperationrecordVo>> paiMap1 = fangpaishuiPumpoperationrecordVoDao.stream().collect(Collectors.groupingBy(FangpaishuiPumpoperationrecordVo::getEquipmentName));
        Set<Map.Entry<String, List<FangpaishuiPumpoperationrecordVo>>> paiEntries1 = paiMap1.entrySet();
        List<FangpaishuiPumpoperationrecordReportVo>  fangpaishuiPumpoperationrecordReportVosDao = new ArrayList<>();
        for(Map.Entry m : paiEntries1){

            FangpaishuiPumpoperationrecordReportVo vo = new FangpaishuiPumpoperationrecordReportVo();
            vo.setEquipmentName((String) m.getKey());
            vo.setFangpaishuiPumpoperationrecordVos((List<FangpaishuiPumpoperationrecordVo>) m.getValue());
            int VolumeByMouth =0;
            for (FangpaishuiPumpoperationrecordVo fangpaishuiPumpoperationrecordVo : (List<FangpaishuiPumpoperationrecordVo>) m.getValue()) {
                VolumeByMouth+=fangpaishuiPumpoperationrecordVo.getVolume();
            }
            vo.setVolumeByMouth(VolumeByMouth);
            fangpaishuiPumpoperationrecordReportVosDao.add( vo);
        }


        FangpaishuiPumpoperationrecordReportByMonthCountVo fPai = new FangpaishuiPumpoperationrecordReportByMonthCountVo();
        fPai.setFangpaishuiPumpoperationrecordReportVos(fangpaishuiPumpoperationrecordReportVosPai);
        int VolumeAllByMouth = 0;
        for (FangpaishuiPumpoperationrecordReportVo fangpaishuiPumpoperationrecordReportVo : fangpaishuiPumpoperationrecordReportVosPai) {
            VolumeAllByMouth+=fangpaishuiPumpoperationrecordReportVo.getVolumeByMouth();
        }
        fPai.setVolumeAllByMouth(VolumeAllByMouth);
        fPai.setType("排水");
        fPai.setVolumeAllByYear(findCount("排水",lastDate));



        FangpaishuiPumpoperationrecordReportByMonthCountVo fDao = new FangpaishuiPumpoperationrecordReportByMonthCountVo();
        fDao.setFangpaishuiPumpoperationrecordReportVos(fangpaishuiPumpoperationrecordReportVosDao);
        int VolumeAllByMouth1 = 0;
        for (FangpaishuiPumpoperationrecordReportVo fangpaishuiPumpoperationrecordReportVo : fangpaishuiPumpoperationrecordReportVosDao) {
            VolumeAllByMouth1+=fangpaishuiPumpoperationrecordReportVo.getVolumeByMouth();
        }
        fDao.setVolumeAllByMouth(VolumeAllByMouth1);
        fDao.setType("倒水");
        fDao.setVolumeAllByYear(findCount("倒水",lastDate));

        FangpaishuiPumpoperationrecordReportByYearCountVo fangpaishuiPumpoperationrecordReportByYearCountVo = new FangpaishuiPumpoperationrecordReportByYearCountVo();
        List<FangpaishuiPumpoperationrecordReportByMonthCountVo> all = new ArrayList<>();
        all.add(fDao);
        all.add(fPai);
        fangpaishuiPumpoperationrecordReportByYearCountVo.setFangpaishuiPumpoperationrecordReportByMonthCountVos(all);
        fangpaishuiPumpoperationrecordReportByYearCountVo.setVolumeByMouthCount(fDao.getVolumeAllByMouth()+fPai.getVolumeAllByMouth());
        fangpaishuiPumpoperationrecordReportByYearCountVo.setVolumeByYearCount(fDao.getVolumeAllByYear()+fPai.getVolumeAllByYear());
        return fangpaishuiPumpoperationrecordReportByYearCountVo;
    }

    @Override
    public int findCount(String type, String lastDate) {
     int year = Integer.valueOf(lastDate.substring(0,4)).intValue()-1;
        String update =String.valueOf(year)+"-12-26";
        return baseMapper.findCount(type,update,lastDate);
    }
}




