package com.jdc.jdcproject.utils;

import org.apache.commons.lang.StringUtils;

import java.text.SimpleDateFormat;
import java.util.Calendar;

public class LastDayOfMonth
{
    /**
     * 获取某月的最后一天
     *
     */
    public final String getLastDayOfMonth(int year,int month)
    {
        Calendar cal = Calendar.getInstance();
        //设置年份
        cal.set(Calendar.YEAR,year);
        //设置月份
        cal.set(Calendar.MONTH, month);
        //获取当月最小值
        int lastDay = cal.getMinimum(Calendar.DAY_OF_MONTH);
        //设置日历中的月份，当月+1月-1天=当月最后一天
        cal.set(Calendar.DAY_OF_MONTH, lastDay-1);
        //格式化日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd");
        String lastDayOfMonth = sdf.format(cal.getTime());
        return lastDayOfMonth;
    }


    //截取最后一个‘-’后的值并计算后拼接
    public final String dateCalculations(String date,int index) {
        String n1 = StringUtils.substringAfterLast(date, "-");//截取最后-后面的数字
        int i = n1.length();
        if ("".equals(n1)) {
            n1 = "0";
        }
        //截取后的值-index
        int nums = Integer.parseInt(n1)-index ;
        //转字符串
        String newNum = String.valueOf(nums);
        i = Math.min(i, newNum.length());
        return date.subSequence(0, date.length() - i) + newNum;

    }
}   

